--[[
local ToolGump = {
      XPos = 0,
      YPos = 0,
      XSize = 0,
}

local Item = {
      itemName = "buckler",
      categoryName = "Shields",
      amount = 10,
      materialName = "Iron",
}

]]--
dofile('../lib/KalOCR.lua')
dofile('../lib/FindItems.lua')

local Buttons = {
      Category = function(categoryIndex)
               local x,y,multipler
               x = 30
               y = 70
               multipler = 20
               return {x,y + multipler * categoryIndex} 
      end,
      Item = function(itemIndex)
               local x,y,multipler
               x = 235
               y = 70
               multipler = 20
               return {x,y + multipler * itemIndex} 
      end,
      BODCombine = function(itemsAmount)
               local x,y,multipler
               x = 140
               y = 200
               multipler = 25
               return {x,y + multipler * (itemsAmount-1)} 
      end,
      Material = {30,390},
      Next = {380,290},
      MakeLast = {285,455},
}

local function pressButton(Gump,Button)
      UO.Click(Gump.XPos+Button[1],Gump.YPos+Button[2],true,true,true,false) 
end

local function findCategoryIndex(Gump,CategoryName)
      local x,y,multipler,textcolor
      x = 50
      y = 63
      multipler = 20
      textcolor = UO.GetPix(Gump.XPos+73,Gump.YPos+49)
      for i=1,11 do
          if CategoryName == KAL.ReadText(Gump.XPos+x,Gump.YPos+y+multipler*i,"IN",textcolor,"TEXT",150) then
             return i
          end    
      end
      UO.SysMessage("Category not found. Halt macro.", 41)
      stop()
      return nil
end

local function findItemIndex(Gump,ItemName,disablePrecision)
      if precision == nil then precision = false end
      local x,y,multipler,textcolor
      x = 255
      y = 63
      multipler = 20
      textcolor = UO.GetPix(Gump.XPos+73,Gump.YPos+49)
      for i=0,9 do
          if (disablePrecision and string.match(KAL.ReadText(Gump.XPos+x,Gump.YPos+y+multipler*i,"IN",textcolor,"TEXT",150),ItemName) ~= nil)
          or ItemName == KAL.ReadText(Gump.XPos+x,Gump.YPos+y+multipler*i,"IN",textcolor,"TEXT",150) then
             return i
          end    
      end
      if disablePrecision then
         UO.SysMessage("Material name not found. Halt macro.", 41)
         stop()
      end
      return nil
end

local function makeItem(Gump,ItemName)
      local itemIndex = findItemIndex(Gump,ItemName)
      if itemIndex == nil then return false end
      pressButton(Gump,Buttons.Item(itemIndex))
      return true    
end

local function useTool(ID)
         if ID ~= 0 then
            UO.LObjectID = ID
            UO.Macro(17,0)
            wait(250)
            return {
                   XPos = UO.ContPosX,
                   YPos = UO.ContPosY,
                   XSize = UO.ContSizeX,
            }
         end
end

local function findTool(toolType,toolColor)
     local t = ScanItems(true,{Type=toolType,Col=toolColor,ContID=UO.BackpackID})
     if table.getn(t) > 0 then return t[1].ID end
     return nil
end

local function setCategory(Gump,CategoryName,page)
       pressButton(Gump,Buttons.Category(findCategoryIndex(Gump,CategoryName)))
       if page ~= nil then
          for i=1,page-1 do
              wait(500)
              pressButton(Gump,Buttons.Next)
          end
       end
end

function setMaterial(Gump,MaterialName)
      pressButton(Gump,Buttons.Material)
      wait(500)
      local itemIndex = findItemIndex(Gump,string.upper(MaterialName),true)
      if itemIndex == nil then return false end
      pressButton(Gump,Buttons.Item(itemIndex))
      return true    
end

local function isDone(Item) 
      local t = ScanItems(true,{Name=Item.itemName,ContID=UO.BackpackID})
      local count = 0
      for i=1,#t do          
          if    
            (
             Item.Quality == 'normal'
             or (Item.Quality == 'exceptional' and (string.match(t[i].Details,"Exceptional") ~= nil or string.match(t[i].Name,"Exceptional") ~= nil))
            ) and (
             ((Item.Material == 'Iron' or Item.Material == 'Leather') and string.lower(t[i].Name) == Item.itemName)
             or string.match(t[i].Name,Item.Material) ~= nil
            )
          then
              count = count + 1
          end
      end
      UO.SysMessage(Item.itemName.." in backpack: "..tostring(count).." of "..tostring(Item.amount), 72)
      if count >= Item.amount then return true end
      return false
end

local function isBODContainsItemsStrictly(BOD,itemsNames)
      if table.getn(BOD.BODInfo.Items) ~= table.getn(itemsNames) then return false end
      local count = 0
      for i=1,#BOD.BODInfo.Items do
          for j=1,#itemsNames do
              if BOD.BODInfo.Items[i].Name == itemsNames[j] then count = count + 1 end 
          end
      end
      if count ~= table.getn(BOD.BODInfo.Items) or count ~= table.getn(itemsNames) then return false end
      return true
end

local function isBODCompleted(BOD)
      for i=1,#BOD.BODInfo.Items do
          if BOD.BODInfo.Items[i].Done ~= BOD.BODInfo.Amount then return false end  
      end
      return true
end

Craft = {
      ToolGumpSizeX = 530
}

Craft.make = function(Item,toolType,toolColor)
      if Item.amount == nil or Item.amount < 1 then Item.amount = 1 end
      if isDone(Item) then return end 
      if toolColor == nil then toolColor = 0 end
      if toolType == nil then
         UO.SysMessage("Tool type not choosen. Halt macro.", 41)
         stop()
      end
      local toolID = findTool(toolType,toolColor)
      if toolID == nil then
         UO.SysMessage("Found no crafting tools. Halt macro.", 41)
         stop()
      end
      local ToolGump = useTool(toolID)
      wait(500)
      setMaterial(ToolGump,Item.Material)
      wait(500)
      setCategory(ToolGump,Item.categoryName)
      wait(500)
      local uglyFix = 0
      while makeItem(ToolGump,Item.itemName) == false do
            if uglyFix > 10 then
               UO.SysMessage("Item's name in tool's list not found. Halt macro.", 41)
               stop()
            end
            pressButton(ToolGump,Buttons.Next)
            uglyFix = uglyFix + 1
            wait(500) 
      end
      wait(1500)
      while isDone(Item) == false do
            if UO.ContName ~= "generic gump" or UO.ContSizeX ~= Craft.ToolGumpSizeX then
               toolID = findTool(toolType,toolColor)
               if toolID == nil then
                  UO.SysMessage("Found no crafting tools. Halt macro.", 41)
                  return false
               end
               ToolGump = useTool(toolID)
               wait(500)
            end    
            pressButton(ToolGump,Buttons.MakeLast)
            wait(1500)
      end
end

Craft.findBOD = function(size,material,quality,amount,itemsNames,stricAmount,completed)
      if stricAmount == nil then stricAmount = false end
      if completed == nil then completed = false end
      local t = ScanItems(true,{Type=8792,ContID=UO.BackpackID})
      for i=1,#t do
          if t[i].BODInfo.Size == size and t[i].BODInfo.Quality == quality and ((stricAmount == false and t[i].BODInfo.Amount >= amount) or (stricAmount and t[i].BODInfo.Amount == amount)) and t[i].BODInfo.Material == material then
              if isBODContainsItemsStrictly(t[i],itemsNames) then
                 if completed and isBODCompleted(t[i]) == false then return nil end
                 return t[i]
              end
          end 
      end
      return nil 
end

Craft.fillBOD = function(BOD)
         if BOD ~= nil and BOD.ID ~= 0 then
            UO.LObjectID = BOD.ID
            UO.Macro(17,0)
            wait(1500)
            local Gump = {
                   XPos = UO.ContPosX,
                   YPos = UO.ContPosY,
                   XSize = UO.ContSizeX,
            }
            pressButton(Gump,Buttons.BODCombine(table.getn(BOD.BODInfo.Items)))
            if BOD.BODInfo.Size == "Small" then
               local t = ScanItems(true,{Name=BOD.BODInfo.Items[1].Name,ContID=UO.BackpackID})
               for i=1,#t do
                   if    
                     (
                         BOD.BODInfo.Quality == 'normal'
                         or (BOD.BODInfo.Quality == 'exceptional' and (string.match(t[i].Details,"Exceptional") ~= nil or string.match(t[i].Name,"Exceptional") ~= nil))
                     ) and (
                         (BOD.BODInfo.Material == 'Iron' or BOD.BODInfo.Material == 'Leather')
                         or string.match(t[i].Name,BOD.BODInfo.Material) ~= nil
                     )
                   then
                       UO.LTargetID = t[i].ID
                       UO.Macro(25,0) -- Wait For Target
                       UO.Macro(22,0) -- Last Target
                   end
               end
            end
            if BOD.BODInfo.Size == "Large" then
               local smallBOD
               for i=1,#BOD.BODInfo.Items do
                   smallBOD = Craft.findBOD("Small",BOD.BODInfo.Material,BOD.BODInfo.Quality,BOD.BODInfo.Amount,{BOD.BODInfo.Items[i].Name},true,true)
                   if smallBOD ~= nil then
                      UO.SysMessage('test.', 42)
                       UO.LTargetID = smallBOD.ID
                       UO.Macro(25,0) -- Wait For Target
                       UO.Macro(22,0) -- Last Target
                   end
               end
            end
         end 
end

UO.SysMessage("modCraft loaded", 72)